;; 
;; *  main MIRACL header - miracl.h.
;; *
;; *  Copyright (c) 1988-2001 Shamus Software Ltd.
;; 
;; ------------------------------------------------
;;
;; *  Masm .inc file v0.0 created by drizz 
;;
;;  - miracl.lib compiled with ddk (bin,inc,lib)
;;  - LINK /NODEFAULTLIB:LIBC.LIB /NODEFAULTLIB:OLDNAMES.LIB
;;  - excluded fp.
;;  - excluded __int64.
;;  - add renamed to adi
;;  - instr renamed to instrz
;;  - size renamed to isize
;;  - reserved words in structures have ending _

; useful macros
mirvars macro args:vararg
	for arg,<args>
		invoke mirvar,0
		mov &arg,eax
	endm
	mirkills macro
		for arg,<args>
			invoke mirkill,&arg
		endm
	endm
	exitm<>
endm
;;[Hack]
.data
public _iob
_iob dd 0; i don't know its use. io byte? 
.const
;;[/Hack]
;
; option expr32	
; option casemap:none
;
; Begin of file miracl.h

mr_small TYPEDEF DWORD
PPDWORD TYPEDEF PTR PTR DWORD
p_mr_small TYPEDEF PTR mr_small

; stdio.h
FILE STRUCT 4
	_ptr PBYTE ?
	_cnt DWORD ?
	_base PBYTE ?
	_flag DWORD ?
	_file DWORD ?
	_charbuf DWORD ?
	_bufsiz DWORD ?
	_tmpfname PBYTE ?
FILE ENDS
PFILE TYPEDEF PTR FILE

; big
bigtype STRUCT 4
	len DWORD ?
	w p_mr_small ?
bigtype ENDS
big TYPEDEF PTR bigtype
pbig TYPEDEF PTR big

; chinese remainder theorem structures 

small_chinese STRUCT 4
	C_ PDWORD ?
	V PDWORD ?
	M PDWORD ?
	NP DWORD ?
small_chinese ENDS

big_chinese STRUCT 4
	C_ pbig ?
	V pbig ?
	M pbig ?
	NP DWORD ?
big_chinese ENDS

; error returns 
MR_ERR_BASE_TOO_BIG EQU 1
MR_ERR_DIV_BY_ZERO EQU 2
MR_ERR_OVERFLOW EQU 3
MR_ERR_NEG_RESULT EQU 4
MR_ERR_BAD_FORMAT EQU 5
MR_ERR_BAD_BASE EQU 6
MR_ERR_BAD_PARAMETERS EQU 7
MR_ERR_OUT_OF_MEMORY EQU 8
MR_ERR_NEG_ROOT EQU 9
MR_ERR_NEG_POWER EQU 10
MR_ERR_BAD_ROOT EQU 11
MR_ERR_INT_OP EQU 12
MR_ERR_FLASH_OVERFLOW EQU 13
MR_ERR_TOO_BIG EQU 14
MR_ERR_NEG_LOG EQU 15
MR_ERR_DOUBLE_FAIL EQU 16
MR_ERR_IO_OVERFLOW EQU 17
MR_ERR_NO_MIRSYS EQU 18
MR_ERR_BAD_MODULUS EQU 19
MR_ERR_NO_MODULUS EQU 20
MR_ERR_EXP_TOO_BIG EQU 21
MR_ERR_NOT_SUPPORTED EQU 22
MR_ERR_NOT_DOUBLE_LEN EQU 23
MR_ERR_NOT_IRREDUC EQU 24
MR_ERR_NO_ROUNDING EQU 25
MR_ERR_NOT_BINARY EQU 26

; some useful definitions 
PLUS EQU 1
MINUS EQU 0ffffffffh
MR_MAXDEPTH EQU 24

MIRACL EQU 32
MR_LITTLE_ENDIAN TEXTEQU <>
mr_utype TEXTEQU <DWORD>
MR_IBITS EQU 32
MR_LBITS EQU 32
mr_unsign32 TEXTEQU <DWORD>
forever TEXTEQU <.while 1>
OFF EQU 0
ON EQU 1
MR_OUT TEXTEQU <dec mr_mip.depth>
MR_MSBIT TEXTEQU <(1 shl 31)>
MR_OBITS TEXTEQU <(MR_MSBIT-1)>
MR_TOOBIG EQU 040000000h
MR_BTS EQU 16
MR_MSK EQU 00000ffffh
MR_HASH_BYTES EQU 20
; Marsaglia & Zaman Random number generator 
;     constants   alternatives    
NK EQU 37; 21
NJ EQU 24;  6 
NV EQU 14;  8 
; Cryptographically strong pseudo-random number generator 
csprng STRUCT 4
	ira DWORD NK DUP (?)
	rndptr DWORD ?
	borrow DWORD ?
	pool_ptr DWORD ?
	pool SBYTE MR_HASH_BYTES DUP (?)
csprng ENDS
tcsprng TYPEDEF csprng

; secure hash Algorithm structure 
sha256 STRUCT 4
	length_ DWORD 2 DUP (?)
	h DWORD 8 DUP (?)
	w DWORD 80 DUP (?)
sha256 ENDS
tsha256 TYPEDEF sha256
tsha TYPEDEF sha256

; advanced encryption algorithm structure 

MR_ECB EQU 0
MR_CBC EQU 1
MR_CFB1 EQU 2
MR_CFB2 EQU 3
MR_CFB4 EQU 5
MR_PCFB1 EQU 10
MR_PCFB2 EQU 11
MR_PCFB4 EQU 13
MR_OFB1 EQU 14
MR_OFB2 EQU 15
MR_OFB4 EQU 17
MR_OFB8 EQU 21
MR_OFB16 EQU 29

aes STRUCT 4
	Nk DWORD ?
	Nr DWORD ?
	mode DWORD ?
	fkey DWORD 60 DUP (?)
	rkey DWORD 60 DUP (?)
	f SBYTE 16 DUP (?)
aes ENDS
taes TYPEDEF aes

; Elliptic curve point status 
MR_EPOINT_GENERAL EQU 0
MR_EPOINT_NORMALIZED EQU 1
MR_EPOINT_INFINITY EQU 2
MR_PROJECTIVE EQU 0
MR_AFFINE EQU 1
; Elliptic Curve epoint structure. Uses projective (X,Y,Z) co-ordinates 
tepoint STRUCT 4
	X big ?
	Y big ?
	Z big ?
	marker DWORD ?
tepoint ENDS
epoint TYPEDEF tepoint
pepoint TYPEDEF PTR PTR epoint

; Structure for Brickell method for finite *
tbrick STRUCT 4
	table pbig ?
	n big ?
	base DWORD ?
	store DWORD ?
tbrick ENDS
brick TYPEDEF tbrick

; Structure for Brickell method for elliptic *

tebrick STRUCT 4
	table pepoint ?
	a big ?
	b big ?
	n big ?
	base DWORD ?
	store DWORD ?
tebrick ENDS
ebrick TYPEDEF tebrick

tebrick2 STRUCT 4
	table pepoint ?
	a6 big ?
	a2 big ?
	m DWORD ?
	a DWORD ?
	b DWORD ?
	c_ DWORD ?
	base DWORD ?
	store DWORD ?
tebrick2 ENDS
ebrick2 TYPEDEF tebrick

miracl STRUCT 4
	base mr_small ?
	apbase mr_small ?
	pack DWORD ?
	lg2b DWORD ?
	base2 mr_small ?
	user DWORD ?
	nib DWORD ?
	depth DWORD ?
	trace DWORD MR_MAXDEPTH DUP (?)
	check BOOL ?
	fout BOOL ?
	fin BOOL ?
	active BOOL ?
	infile PFILE ?
	otfile PFILE ?
	ira DWORD NK DUP (?)
	rndptr DWORD ?
	borrow DWORD ?
	ndash mr_small ?
	modulus big ?
	ACTIVE BOOL ?
	MONTY BOOL ?
	SS_ BOOL ?
	A big ?
	B big ?
	C_ big ?
	coord DWORD ?
	Asize DWORD ?
	Bsize DWORD ?
	M DWORD ?
	AA DWORD ?
	BB DWORD ?
	CC DWORD ?
	logN DWORD ?
	nprimes DWORD ?
	degree DWORD ?
	prime PDWORD ?
	cr PDWORD ?
	inverse PDWORD ?
	roots PPDWORD ?
	chin small_chinese <>
	const1 DWORD ?
	const2 DWORD ?
	const3 DWORD ?
	msw mr_small ?
	lsw mr_small ?
	s1 PPDWORD ?
	s2 PPDWORD ?
	t PPDWORD ?
	wa PDWORD ?
	wb PDWORD ?
	wc PDWORD ?
	same BOOL ?
	first_one BOOL ?
	debug BOOL ?
	w0 big ?
	w1 big ?
	w2 big ?
	w3 big ?
	w4 big ?
	w5 big ?
	w6 big ?
	w7 big ?
	w8 big ?
	w9 big ?
	w10 big ?
	w11 big ?
	w12 big ?
	w13 big ?
	w14 big ?
	w15 big ?
	w16 big ?
	w17 big ?
	w18 big ?
	IOBUFF PBYTE ?
	IOBSIZ DWORD ?
	ERCON BOOL ?
	ERNUM DWORD ?
	NTRY DWORD ?
	IOBASE DWORD ?
	EXACT BOOL ?
	RPOINT BOOL ?
	TRACER BOOL ?
	INPLEN DWORD ?
	PRIMES PDWORD ?
	workprec DWORD ?
	stprec DWORD ?
	RS DWORD ?
	RD DWORD ?
	D REAL8 ?
	db_ REAL8 ?
	n REAL8 ?
	p REAL8 ?
	a DWORD ?
	b DWORD ?
	c_ DWORD ?
	d DWORD ?
	r DWORD ?
	q DWORD ?
	oldn DWORD ?
	ndig DWORD ?
	u mr_small ?
	v mr_small ?
	ku mr_small ?
	kv mr_small ?
	last BOOL ?
	carryon BOOL ?
	pi big ?
	size_ DWORD ?
	workspace PBYTE ?
	TWIST BOOL ?
	qnr DWORD ?
miracl ENDS

EXTERNDEF C mr_mip:PTR miracl

; Function definitions 
; Group 0 - Internal routines 
mr_berror PROTO C :DWORD
mr_shiftbits PROTO C :mr_small, :DWORD
mr_setbase PROTO C :mr_small
mr_track PROTO C 
mr_lzero PROTO C :big
mr_notint PROTO C :big
mr_lent PROTO C :big
mr_padd PROTO C :big, :big, :big
mr_psub PROTO C :big, :big, :big
mr_pmul PROTO C :big, :mr_small, :big
mr_sdiv PROTO C :big, :mr_small, :big
mr_shift PROTO C :big, :DWORD, :big
mr_first_alloc PROTO C 
mr_alloc PROTO C :DWORD, :DWORD
mr_free PROTO C :PTR 
set_user_function PROTO C :PTR
set_io_buffer_size PROTO C :DWORD
mr_testbit PROTO C :big, :DWORD
mr_window PROTO C :big, :DWORD, :PTR DWORD, :PTR DWORD
mr_window2 PROTO C :big, :big, :DWORD, :PTR DWORD, :PTR DWORD
mr_naf_window PROTO C :big, :big, :DWORD, :PTR DWORD, :PTR DWORD
mr_fft_init PROTO C :DWORD, :big, :big, :BOOL
mr_dif_fft PROTO C :DWORD, :DWORD, :PTR DWORD
mr_dit_fft PROTO C :DWORD, :DWORD, :PTR DWORD
fft_reset PROTO C 
mr_poly_mul PROTO C :DWORD, :PTR big, :DWORD, :PTR big, :PTR big
mr_poly_sqr PROTO C :DWORD, :PTR big, :PTR big
mr_polymod_set PROTO C :DWORD, :PTR big, :PTR big
mr_poly_rem PROTO C :DWORD, :PTR big, :PTR big
mr_ps_big_mul PROTO C :DWORD, :PTR big, :PTR big, :PTR big
mr_ps_zzn_mul PROTO C :DWORD, :PTR big, :PTR big, :PTR big
muldiv PROTO C :mr_small, :mr_small, :mr_small, :mr_small, :PTR mr_small
muldvm PROTO C :mr_small, :mr_small, :mr_small, :PTR mr_small
muldvd PROTO C :mr_small, :mr_small, :mr_small, :PTR mr_small
muldvd2 PROTO C :mr_small, :mr_small, :PTR mr_small, :PTR mr_small
; Group 1 - General purpose, I/O and basic arithmetic routines 
igcd PROTO C :DWORD, :DWORD
sgcd PROTO C :mr_small, :mr_small
isqrt PROTO C :DWORD, :DWORD
irand PROTO C :DWORD
brand PROTO C 
zero PROTO C :big
convert PROTO C :DWORD, :big
lgconv PROTO C :DWORD, :big
mirvar PROTO C :DWORD
mirvar_mem PROTO C :PTR BYTE, :DWORD
mirkill PROTO C :big
memalloc PROTO C :DWORD
memkill PROTO C :PTR BYTE, :DWORD
mr_init_threading PROTO C 
mr_end_threading PROTO C 
get_mip PROTO C 
mirsys PROTO C :DWORD, :mr_small
mirexit PROTO C 
exsign PROTO C :big
insign PROTO C :DWORD, :big
getdig PROTO C :big, :DWORD
numdig PROTO C :big
putdig PROTO C :DWORD, :big, :DWORD
copy PROTO C :big, :big
negify PROTO C :big, :big
absol PROTO C :big, :big
isize PROTO C :big
compare PROTO C :big, :big
adi PROTO C :big, :big, :big
subtract PROTO C :big, :big, :big
incr PROTO C :big, :DWORD, :big
decr PROTO C :big, :DWORD, :big
premult PROTO C :big, :DWORD, :big
subdiv PROTO C :big, :DWORD, :big
subdivisible PROTO C :big, :DWORD
remain PROTO C :big, :DWORD
bytes_to_big PROTO C :DWORD, :PTR BYTE, :big
big_to_bytes PROTO C :DWORD, :big, :PTR BYTE, :BOOL
normalise PROTO C :big, :big
multiply PROTO C :big, :big, :big
fft_mult PROTO C :big, :big, :big
fastmultop PROTO C :DWORD, :big, :big, :big
divide PROTO C :big, :big, :big
divisible PROTO C :big, :big
mad PROTO C :big, :big, :big, :big, :big, :big
instrz PROTO C :big, :PTR BYTE
otstr PROTO C :big, :PTR BYTE
cinstr PROTO C :big, :PTR BYTE
cotstr PROTO C :big, :PTR BYTE
innum PROTO C :big, :PTR FILE
otnum PROTO C :big, :PTR FILE
cinnum PROTO C :big, :PTR FILE
cotnum PROTO C :big, :PTR FILE
; Group 2 - Advanced arithmetic routines 
smul PROTO C :mr_small, :mr_small, :mr_small
spmd PROTO C :mr_small, :mr_small, :mr_small
invers PROTO C :mr_small, :mr_small
sqrmp PROTO C :mr_small, :mr_small
jac PROTO C :mr_small, :mr_small
gprime PROTO C :DWORD
jack PROTO C :big, :big
egcd PROTO C :big, :big, :big
xgcd PROTO C :big, :big, :big, :big, :big
logb2 PROTO C :big
expint PROTO C :DWORD, :DWORD, :big
sftbit PROTO C :big, :DWORD, :big
power PROTO C :big, :DWORD, :big, :big
powmod PROTO C :big, :big, :big, :big
powmod2 PROTO C :big, :big, :big, :big, :big, :big
powmodn PROTO C :DWORD, :PTR big, :PTR big, :big, :big
powltr PROTO C :DWORD, :big, :big, :big
double_inverse PROTO C :big, :big, :big, :big, :big
multi_inverse PROTO C :DWORD, :PTR big, :big, :PTR big
lucas PROTO C :big, :big, :big, :big, :big
nroot PROTO C :big, :DWORD, :big
sqroot PROTO C :big, :big, :big
bigrand PROTO C :big, :big
bigdig PROTO C :DWORD, :DWORD, :big
trial_division PROTO C :big, :big
isprime PROTO C :big
nxprime PROTO C :big, :big
nxsafeprime PROTO C :DWORD, :DWORD, :big, :big
crt_init PROTO C :PTR big_chinese, :DWORD, :PTR big
crt PROTO C :PTR big_chinese, :PTR big, :big
crt_end PROTO C :PTR big_chinese
scrt_init PROTO C :PTR small_chinese, :DWORD, :PTR DWORD
scrt PROTO C :PTR small_chinese, :PTR DWORD, :big
scrt_end PROTO C :PTR small_chinese
brick_init PROTO C :PTR brick, :big, :big, :DWORD
pow_brick PROTO C :PTR brick, :big, :big
brick_end PROTO C :PTR brick
ebrick_init PROTO C :PTR ebrick, :big, :big, :big, :big, :big, :DWORD
ebrick_end PROTO C :PTR ebrick
mul_brick PROTO C :PTR ebrick, :big, :big, :big
ebrick2_init PROTO C :PTR ebrick2, :big, :big, :big, :big, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
ebrick2_end PROTO C :PTR ebrick2
mul2_brick PROTO C :PTR ebrick2, :big, :big, :big
; Montgomery stuff 
prepare_monty PROTO C :big
kill_monty PROTO C 
nres PROTO C :big, :big
redc PROTO C :big, :big
nres_negate PROTO C :big, :big
nres_modadd PROTO C :big, :big, :big
nres_modsub PROTO C :big, :big, :big
nres_premult PROTO C :big, :DWORD, :big
nres_modmult PROTO C :big, :big, :big
nres_moddiv PROTO C :big, :big, :big
nres_dotprod PROTO C :DWORD, :PTR big, :PTR big, :big
nres_powmod PROTO C :big, :big, :big
nres_powltr PROTO C :DWORD, :big, :big
nres_powmod2 PROTO C :big, :big, :big, :big, :big
nres_powmodn PROTO C :DWORD, :PTR big, :PTR big, :big
nres_sqroot PROTO C :big, :big
nres_lucas PROTO C :big, :big, :big, :big
nres_double_inverse PROTO C :big, :big, :big, :big
nres_multi_inverse PROTO C :DWORD, :PTR big, :PTR big
shs_init PROTO C :PTR sha
shs_process PROTO C :PTR sha, :DWORD
shs_hash PROTO C :PTR sha, :PTR BYTE
shs256_init PROTO C :PTR sha256
shs256_process PROTO C :PTR sha256, :DWORD
shs256_hash PROTO C :PTR sha256, :PTR BYTE
aes_init PROTO C :PTR aes, :DWORD, :DWORD, :PTR BYTE, :PTR BYTE
aes_getreg PROTO C :PTR aes, :PTR BYTE
aes_encrypt PROTO C :PTR aes, :PTR BYTE
aes_decrypt PROTO C :PTR aes, :PTR BYTE
aes_reset PROTO C :PTR aes, :DWORD, :PTR BYTE
aes_end PROTO C :PTR aes
strong_init PROTO C :PTR csprng, :DWORD, :PTR BYTE, :DWORD
strong_rng PROTO C :PTR csprng
strong_bigrand PROTO C :PTR csprng, :big, :big
strong_bigdig PROTO C :PTR csprng, :DWORD, :DWORD, :big
strong_kill PROTO C :PTR csprng
; special modular multipliers 
comba_mult PROTO C :big, :big, :big
comba_square PROTO C :big, :big
comba_redc PROTO C :big, :big
comba_add PROTO C :big, :big, :big
comba_sub PROTO C :big, :big, :big
fastmodmult PROTO C :big, :big, :big
fastmodsquare PROTO C :big, :big
kcm_mul PROTO C :big, :big, :big
kcm_sqr PROTO C :big, :big
kcm_redc PROTO C :big, :big
kcm_multiply PROTO C :DWORD, :big, :big, :big
kcm_square PROTO C :DWORD, :big, :big
kcm_top PROTO C :DWORD, :big, :big, :big
; elliptic curve stuff 
point_at_infinity PROTO C :PTR epoint
ecurve_init PROTO C :big, :big, :big, :DWORD
ecurve_add PROTO C :PTR epoint, :PTR epoint
ecurve_sub PROTO C :PTR epoint, :PTR epoint
ecurve_double_add PROTO C :PTR epoint, :PTR epoint, :PTR epoint, :PTR epoint, :PTR big, :PTR big
ecurve_multi_add PROTO C :DWORD, :PTR PTR epoint, :PTR PTR epoint
ecurve_mult PROTO C :big, :PTR epoint, :PTR epoint
ecurve_mult2 PROTO C :big, :PTR epoint, :big, :PTR epoint, :PTR epoint
ecurve_multn PROTO C :DWORD, :PTR big, :PTR PTR epoint, :PTR epoint
epoint_init PROTO C 
epoint_set PROTO C :big, :big, :DWORD, :PTR epoint
epoint_get PROTO C :PTR epoint, :big, :big
epoint_getxyz PROTO C :PTR epoint, :big, :big, :big
epoint_norm PROTO C :PTR epoint
epoint_free PROTO C :PTR epoint
epoint_copy PROTO C :PTR epoint, :PTR epoint
epoint_comp PROTO C :PTR epoint, :PTR epoint
epoint_negate PROTO C :PTR epoint
ecurve2_init PROTO C :DWORD, :DWORD, :DWORD, :DWORD, :big, :big, :BOOL, :DWORD
ecurve2_add PROTO C :PTR epoint, :PTR epoint
ecurve2_sub PROTO C :PTR epoint, :PTR epoint
ecurve2_multi_add PROTO C :DWORD, :PTR PTR epoint, :PTR PTR epoint
ecurve2_mult PROTO C :big, :PTR epoint, :PTR epoint
ecurve2_mult2 PROTO C :big, :PTR epoint, :big, :PTR epoint, :PTR epoint
ecurve2_multn PROTO C :DWORD, :PTR big, :PTR PTR epoint, :PTR epoint
epoint2_init PROTO C 
epoint2_set PROTO C :big, :big, :DWORD, :PTR epoint
epoint2_get PROTO C :PTR epoint, :big, :big
epoint2_getxyz PROTO C :PTR epoint, :big, :big, :big
epoint2_norm PROTO C :PTR epoint
epoint2_free PROTO C :PTR epoint
epoint2_copy PROTO C :PTR epoint, :PTR epoint
epoint2_comp PROTO C :PTR epoint, :PTR epoint
epoint2_negate PROTO C :PTR epoint
; GF(2) stuff 
prepare_basis PROTO C :DWORD, :DWORD, :DWORD, :DWORD, :BOOL
add2 PROTO C :big, :big, :big
incr2 PROTO C :big, :DWORD, :big
reduce2 PROTO C :big, :big
modmult2 PROTO C :big, :big, :big
power2 PROTO C :big, :DWORD, :big
sqroot2 PROTO C :big, :big
inverse2 PROTO C :big, :big
karmul2 PROTO C :DWORD, :PTR mr_small, :PTR mr_small, :PTR mr_small, :PTR mr_small
karmul2_poly PROTO C :DWORD, :PTR big, :PTR big, :PTR big, :PTR big
karmul2_poly_upper PROTO C :DWORD, :PTR big, :PTR big, :PTR big, :PTR big
gf2m_dotprod PROTO C :DWORD, :PTR big, :PTR big, :big
trace2 PROTO C :big

;; Group 3 - Floating-slash routines /*REMOVED*/
;; Group 4 - Advanced Flash routines /*REMOVED*/ 
;; End of file miracl.h
